#include "LiquidCrystal.h"
#include "Max6675.h"
#include <EEPROM.h>
#include<CountUpDownTimer.h>
CountUpDownTimer T(DOWN);
LiquidCrystal lcd(A2,  A1,  4,  5,  6,  12, 11);
         // LCD pins: RS  RW  EN  D4  D5  D6  D7
Max6675 tc(9, 8, 7);

uint8_t tempa[8] = {0b00100,0b01010,0b01010,0b01010,0b01010,0b11111,0b11111,0b01110};
uint8_t tempb[8] = {0b00100,0b01010,0b01010,0b01110,0b01110,0b11111,0b11111,0b01110};
uint8_t tempc[8] = {0b00100,0b01010,0b01110,0b01110,0b01110,0b11111,0b11111,0b01110};
uint8_t tempd[8] = {0b00100,0b01110,0b01110,0b01110,0b01110,0b11111,0b11111,0b01110};
uint8_t temp2[8] = {0b00100,0b01010,0b01010,0b01010,0b01010,0b10001,0b10001,0b01110};
uint8_t temp1[8] = {0b00100,0b01010,0b01010,0b01010,0b01010,0b10001,0b11111,0b01110};
uint8_t degre[8] = {0b01100,0b10010,0b10010,0b01100,0b00000,0b00000,0b00000,0b00000};

int val; 
int OK = A0;
int relay = 10;
int led = 13;
int buzzer = A3;
int vetrak = 1;
int stateOUT1 = 0;
int stateOUT2 = LOW;
int previous = LOW;
long time = 0;
long debounce = 500;
unsigned long cas = 0;
unsigned long cas2 = 0;
int stav = 1;
float teplota = 50.0;
int teplotaakt=0;
int stime = 0;
int hodiny = 0;
int minuty = 0; 

int fansp = 0;
int fanspe = 0;
int i=0;
int u=0;
int o=0;
int aa=0;
int mod12=0;
int mod13=0;
int encoderPin1 = 2;
int encoderPin2 = 3;
volatile int lastEncoded = 0;
volatile long encoderValue = 0;
long lastencoderValue = 0;
int lastMSB = 0;
int lastLSB = 0;
volatile int lastEncodeda = 0;
volatile long encoderValuea = 0;
long lastencoderValuea = 0;
int lastMSBa = 0;
int lastLSBa = 0;
volatile int lastEncodedb = 0;
volatile long encoderValueb = 0;
long lastencoderValueb = 0;
int lastMSBb = 0;
int lastLSBb = 0;
int ofset = 0;
int upozornenie = 0;
int kalibracia = LOW;
float teplotana1;
unsigned long cascakania = 0;



 void setup() { 
   tc.setOffset(1);
   attachInterrupt(0, calibration, CHANGE); 
   attachInterrupt(1, calibration, CHANGE);
   pinMode(encoderPin1, INPUT); 
   pinMode(encoderPin2, INPUT);
   pinMode(relay, OUTPUT);
   pinMode(led, OUTPUT);
   pinMode(buzzer, OUTPUT);
   pinMode(OK,INPUT_PULLUP);
   pinMode(vetrak, OUTPUT);
   lcd.begin(8, 2);
   lcd.createChar(3, tempa);
   lcd.createChar(4, tempb);
   lcd.createChar(5, tempc);
   lcd.createChar(6, tempd);
   lcd.createChar(1, temp2);
   lcd.createChar(0, temp1);
   lcd.createChar(2, degre);
   lcd.setCursor(0,0);
   lcd.print("MINI UNI");
   lcd.setCursor(0,1);
   lcd.print("  RURA");
   delay(2000);
   lcd.clear();
   delay(100);
   int d=0;
   
   while(digitalRead(OK) == LOW){
    lcd.setCursor(0,0);
    lcd.print("STARY");
    lcd.setCursor(0,1);
    lcd.print("OFSET:");
    lcd.setCursor(6,1);
    lcd.print(EEPROM.read(3));
    kalibracia = HIGH;
   }
  if(EEPROM.read(5)!= 5){
     kalibracia = HIGH; 
   }
   while(kalibracia == HIGH && digitalRead(OK) == HIGH ){
    if( d<1){
      d++;
      digitalWrite(buzzer,HIGH);
      delay(50);
      digitalWrite(buzzer,LOW);
      delay(50);
    }
    lcd.setCursor(0,0);
    lcd.print("OFSET:");
    lcd.setCursor(6,0);
    lcd.print(ofset);
    if(ofset < 10){
    lcd.setCursor(7,0);
    lcd.print(" ");
    }
    tc.setOffset(ofset);
    if(ofset != EEPROM.read(3)){
         EEPROM.write(3, ofset);
    }
    lcd.setCursor(0,1);
    lcd.write((uint8_t)3);
    lcd.setCursor(1,1);
    lcd.print(tc.getCelsius(),1);
    lcd.setCursor(6,1);
    lcd.write((uint8_t)2);
    lcd.setCursor(7,1);
    lcd.print ("C");
    delay(400);
    EEPROM.write(5, 5);
   }
   ofset = EEPROM.read(3);
   tc.setOffset(ofset);
   lcd.clear();
 } 


 void loop() { // loop -------------------------------------------------------------------------------
 T.Timer(); // run the timer
 int stateButton = digitalRead(OK);
 if(stateButton == LOW && previous == HIGH && millis() - time > debounce) {
    stateOUT1++;
    if(stateOUT1 == 3){
      stateOUT1 = 0; 
    }
    time = millis();
  }
  
  if(stateOUT1 == 0){
   attachInterrupt(0, updateEncoder, CHANGE); 
   attachInterrupt(1, updateEncoder, CHANGE);
  }
  if(stateOUT1 == 1 && stateOUT2 == LOW ){
   attachInterrupt(0, settime, CHANGE); 
   attachInterrupt(1, settime, CHANGE);
  }
   if(stateOUT1 == 2){
   detachInterrupt(0); 
   detachInterrupt(1);
  }
  if(stateOUT1 == 1 && stateOUT2 == HIGH){
   detachInterrupt(0); 
   detachInterrupt(1);
  }
  
  
  previous = stateButton;
   if(stateButton == LOW && stav == 1){
      cas=millis();
      stav=2;
     }
   if(stateButton == HIGH && stav == 2){
      stav=1;
      cas2 = millis() - cas;

if(cas2 > 1000){
   if(stateOUT2 == LOW){
      stateOUT2 = HIGH; 
     } else {
       stateOUT2 = LOW; 
     }
   }
 }
   //-------------------------------------------------------------------------------- 
   if(millis() - cascakania > 400){
     teplotaakt = tc.getCelsius();
     teplotana1 = tc.getCelsius();
     cascakania = millis();
 }
 
   if (stateOUT1 == 0){ 
      mod12=0; 
      if(mod13==0){
        mod13=1;
        lcd.clear();
      }
   int teplotaset = encoderValue / 4;
    teplota = teplotaset + 50;
    if(teplota < 40){
      teplota = 40;
    }
     if(teplota > 250){
      teplota = 250;
    }
 
   lcd.setCursor(0,0);
   lcd.write((uint8_t)1);
   lcd.setCursor(1,1);
   lcd.print(teplotana1);
   lcd.setCursor(1,0);
   lcd.print(teplota);
  if(teplota < 100){
     lcd.setCursor(5,0);
     lcd.print (" ");
   }
   if(teplotaakt < 100){
     lcd.setCursor(5,1);
     lcd.print (" ");
   }
   lcd.setCursor(6,0);
   lcd.write((uint8_t)2);
   lcd.setCursor(6,1);
   lcd.write((uint8_t)2);
   lcd.setCursor(7,0);
   lcd.print ("C");
   lcd.setCursor(7,1);
   lcd.print ("C");
    if(teplotaakt < 50) {lcd.setCursor(0,1);lcd.write((uint8_t)0);}
    if(teplotaakt > 50) {lcd.setCursor(0,1);lcd.write((uint8_t)3);}
    if(teplotaakt > 100){lcd.setCursor(0,1);lcd.write((uint8_t)4);}
    if(teplotaakt > 150){lcd.setCursor(0,1);lcd.write((uint8_t)5);}
    if(teplotaakt > 250){lcd.setCursor(0,1);lcd.write((uint8_t)6);}
    }
    
     if (stateOUT1 == 1){
        mod13=0;
      if(mod12==0){
        mod12=1;
        lcd.clear();
      }
        if(hodiny < 10){
           lcd.setCursor(2,0);
           lcd.print(hodiny);
           lcd.setCursor(1,0);
           lcd.print("0");
        }
        if(hodiny > 9){
           lcd.setCursor(1,0);
           lcd.print(hodiny);
        }
        if(minuty < 10){
           lcd.setCursor(6,0);
           lcd.print(minuty);
           lcd.setCursor(5,0);
           lcd.print("0");
        }
        if(minuty > 9){
           lcd.setCursor(5,0);
           lcd.print(minuty);
        }
        lcd.setCursor(3,0);
        lcd.print("::");
        lcd.setCursor(0,1);
       if(T.ShowHours() < 10){
           lcd.setCursor(1,1);
           lcd.print(T.ShowHours());
           lcd.setCursor(0,1);
           lcd.print("0");
        }
        if(T.ShowHours() > 9){
           lcd.setCursor(0,1);
           lcd.print(T.ShowHours());
        }
        lcd.setCursor(2,1);
        lcd.print(":");
        if(T.ShowMinutes() < 10){
           lcd.setCursor(4,1);
           lcd.print(T.ShowMinutes());
           lcd.setCursor(3,1);
           lcd.print("0");
        }
         if(T.ShowMinutes() > 9){
           lcd.setCursor(3,1);
           lcd.print(T.ShowMinutes());
        }
        lcd.setCursor(5,1);
        lcd.print(":");
        if(T.ShowSeconds() < 10){
           lcd.setCursor(7,1);
           lcd.print(T.ShowSeconds());
           lcd.setCursor(6,1);
           lcd.print("0");
        }
        if(T.ShowSeconds() > 9){
           lcd.setCursor(6,1);
           lcd.print(T.ShowSeconds());
        }
        
     }
     if (stateOUT1 == 2){
         lcd.setCursor(1,0);
         lcd.print(teplotana1); // 1 na jedno desatine miesto , 2 na 2 des . miesta
         lcd.setCursor(6,0);
         lcd.write((uint8_t)2);
         lcd.setCursor(7,0);
         lcd.print ("C");
         if(teplotaakt < 50) {lcd.setCursor(0,0);lcd.write((uint8_t)0);}
         if(teplotaakt > 50) {lcd.setCursor(0,0);lcd.write((uint8_t)3);}
         if(teplotaakt > 100){lcd.setCursor(0,0);lcd.write((uint8_t)4);}
         if(teplotaakt > 150){lcd.setCursor(0,0);lcd.write((uint8_t)5);}
         if(teplotaakt > 250){lcd.setCursor(0,0);lcd.write((uint8_t)6);}
         //----------------------------------------------------------------
     if(stime > 0){
         if(T.ShowHours() < 10){
           lcd.setCursor(1,1);
           lcd.print(T.ShowHours());
           lcd.setCursor(0,1);
           lcd.print("0");
        }
        if(T.ShowHours() > 9){
           lcd.setCursor(0,1);
           lcd.print(T.ShowHours());
        }
        lcd.setCursor(2,1);
        lcd.print(":");
        if(T.ShowMinutes() < 10){
           lcd.setCursor(4,1);
           lcd.print(T.ShowMinutes());
           lcd.setCursor(3,1);
           lcd.print("0");
        }
         if(T.ShowMinutes() > 9){
           lcd.setCursor(3,1);
           lcd.print(T.ShowMinutes());
        }
        lcd.setCursor(5,1);
        lcd.print(":");
        if(T.ShowSeconds() < 10){
           lcd.setCursor(7,1);
           lcd.print(T.ShowSeconds());
           lcd.setCursor(6,1);
           lcd.print("0");
        }
        if(T.ShowSeconds() > 9){
           lcd.setCursor(6,1);
           lcd.print(T.ShowSeconds());
        }
        }
         if(T.ShowHours() == 0 && T.ShowMinutes() == 0 && T.ShowSeconds() == 0){
        lcd.setCursor(0,1);
        lcd.print("00:00:00");
         }
        //------------------------------------------------------------------

      
     }
     

   //--------------------------------------------------------------------------------
    if(stateOUT2 == HIGH){
      if(u==0){
        u=1;
        o=0;
        mod13=0;
        mod12=0;
        lcd.clear();
        lcd.setCursor(0,0);
        lcd.print("OHREV");
        lcd.setCursor(0,1);
        lcd.print("ZAPNUTY");
        digitalWrite(buzzer,HIGH);
        delay(200);
        digitalWrite(buzzer,LOW);
        delay(800);
        lcd.clear();
      }
    int teplota3 = teplota - 2;
    if(teplotaakt < teplota3){
      upozornenie = 0;  
      digitalWrite(led, HIGH);
      digitalWrite(relay, HIGH);
    } 
    if(teplotaakt == teplota && i==0){
      i=1;
      if(stime  > 0){
         T.ResetTimer();
         T.SetTimer(hodiny,minuty,0); // zacatie casovaca
         T.StartTimer();
         aa=1;
         delay(100);
        } 
      digitalWrite(buzzer,HIGH);
      delay(50);
      digitalWrite(buzzer,LOW);
      delay(50);
      digitalWrite(buzzer,HIGH);
      delay(50);
      digitalWrite(buzzer,LOW);
      delay(50);
      digitalWrite(buzzer,HIGH);
      delay(50);
      digitalWrite(buzzer,LOW);
    }    
    
    if(T.ShowHours() == 0 && T.ShowMinutes() == 0 && T.ShowSeconds() == 0 && aa==1 ){
      u=0;
      digitalWrite(led, LOW);
      digitalWrite(relay, LOW);
      stateOUT2 = LOW;
      i=0;
      lcd.clear();
      while(digitalRead(OK) == HIGH){
        lcd.setCursor(1,0);
        lcd.print("KONIEC");
        lcd.setCursor(2,1);
        lcd.print("!!!!");
        digitalWrite(buzzer, HIGH);
        delay(200);
        digitalWrite(buzzer, LOW);
        delay(400);
      }
      lcd.clear();
    }
    
    
    int teplota2 = teplota + 2;
    if(teplotaakt > teplota2){
      digitalWrite(led, LOW);
      digitalWrite(relay, LOW);
    }
    }
    
    if(stateOUT2 == LOW){    
      aa=0;
      digitalWrite(led, LOW);
      digitalWrite(relay, LOW);
    }
    if(stateOUT2 == LOW && u==1){
       if(o==0){
        o=1;
        u=0;
        i=0;
        aa=0;
        mod13=0;
        mod12=0;
        T.StopTimer();
        T.SetTimer(0,0,001);
        lcd.clear();
        lcd.setCursor(0,0);
        lcd.print("OHREV");
        lcd.setCursor(0,1);
        lcd.print("VYPNUTY");
        digitalWrite(buzzer,HIGH);
        delay(400);
        digitalWrite(buzzer,LOW);
        delay(800);
        lcd.clear();
      }
      }
      

       if(stateOUT2 == LOW && teplotaakt > 50 ){
         digitalWrite(vetrak, HIGH);
         fansp = 1;
      }
       if(stateOUT2 == LOW && teplotaakt < 50 && fanspe == 0 ){
         digitalWrite(vetrak, LOW);
         fansp = 0;
      }
      
      if(GetTemp() > 35){
        digitalWrite(vetrak, HIGH);
        fanspe = 1;
      }
      if(GetTemp() < 27 && fansp == 0){
        digitalWrite(vetrak, LOW);
        fanspe = 0;
      }
      
      while(GetTemp() > 55){
        lcd.clear();
         while(GetTemp() > 45){
          digitalWrite(relay, LOW);
          lcd.setCursor(1,0);
          lcd.print("VYSOKA");
          lcd.setCursor(0,1);
          lcd.print("TEPLOTA!");
          T.StopTimer();
          T.SetTimer(0,0,001);
          digitalWrite(led, LOW);
          delay(100);
          digitalWrite(led, HIGH);
          delay(100);         
          stateOUT2 = LOW;
          if(upozornenie < 2){
            upozornenie++;
            digitalWrite(buzzer, HIGH);
            }else{
              digitalWrite(buzzer, LOW);
            }
         }
      }
   upozornenie = 0;     
                           //  0,4 sekund meria  -- STRATA V CASE MESKANIE !!!
 } 
 
void updateEncoder(){
  int MSB = digitalRead(encoderPin1); 
  int LSB = digitalRead(encoderPin2); 
  int encoded = (MSB << 1) |LSB; 
  int sum  = (lastEncoded << 2) | encoded; 
  if(sum == 0b1101 || sum == 0b0100 || sum == 0b0010 || sum == 0b1011) encoderValue ++;
  if(sum == 0b1110 || sum == 0b0111 || sum == 0b0001 || sum == 0b1000) encoderValue --;
  lastEncoded = encoded; 
     if( encoderValue > 800){
      encoderValue = 800;
    }
     if( encoderValue < -50){
      encoderValue = -50;
    }
  
}

void calibration(){
  int MSBa = digitalRead(encoderPin1); 
  int LSBa = digitalRead(encoderPin2); 
  int encodeda = (MSBa << 1) |LSBa; 
  int suma  = (lastEncodeda << 2) | encodeda;
  if(suma == 0b1101 || suma == 0b0100 || suma == 0b0010 || suma == 0b1011) encoderValuea ++;
  if(suma == 0b1110 || suma == 0b0111 || suma == 0b0001 || suma == 0b1000) encoderValuea --;
  lastEncodeda = encodeda; 
   ofset =  encoderValuea / 4;
    if(encoderValuea < 0){
       encoderValuea = 0;
    }
    if(encoderValuea > 125){
       encoderValuea = 125;
    }
}
void settime(){
  int MSBb = digitalRead(encoderPin1); 
  int LSBb = digitalRead(encoderPin2); 
  int encodedb = (MSBb << 1) |LSBb; 
  int sumb  = (lastEncodedb << 2) | encodedb; 
  if(sumb == 0b1101 || sumb == 0b0100 || sumb == 0b0010 || sumb == 0b1011) encoderValueb ++;
  if(sumb == 0b1110 || sumb == 0b0111 || sumb == 0b0001 || sumb == 0b1000) encoderValueb --;
  lastEncodedb = encodedb; 
  stime = encoderValueb / 4 ;
  
  if (encoderValueb < 0){
    encoderValueb = 0;
  }
  
hodiny = stime/60;
minuty = stime-(60*hodiny);
}

double GetTemp(void) // interna teplota
{
  unsigned int wADC;
  double t;
  ADMUX = (_BV(REFS1) | _BV(REFS0) | _BV(MUX3));
  ADCSRA |= _BV(ADEN);
  delay(20);
  ADCSRA |= _BV(ADSC);
  while (bit_is_set(ADCSRA,ADSC));
  wADC = ADCW;
  t = (wADC - 324.31 ) / 1.22;
  return (t);
}

